<?PHP
/**************************** php ipblocker ****************************
*                     http://phpipblocker.evcz.tk                      *
*                             version 0.99a                            *
*                                                                      *
*     developed by EvolutionCrazy (AKA evcz) for B.I.S.S. forum ;)     *
*                             evcz@evcz.tk                             *
*                                                                      *
*    Script distributed under GNU/GPL license (version 2 or higher)    *
*                                                                      *
*                    comments and suggestion here:                     *
*       http://www.bluetack.co.uk/forums/index.php?showforum=156       *
*                                                                      *
***********************************************************************/


//START CONFIGURATION
	//fullpath where maintain dir is located (must end with /)
	//place here the FULLPATH of the structure of the filesystem!
	//if you don't know what's your fullpathname simply use this tool to discover it:
	//http://www.bluetack.co.uk/phpipblocker/fullpathname.zip
	//then add at the end of the string "maintain/" ^_'
	$fullpathMaintain = "/membri/evcz/maintain/";
//END CONFIGURATION


//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//Don't  touch anything after this line (unless you want to modify the script core ^_' )
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

//START SCRIPT CODE
if(!@include($fullpathMaintain."functions.php"))
	die("Unable to include <b>funtions.php</b>... cannot proceed... check the <b>\"fullpathMaintain\"</b> dir is correctly set in <b>ban.php</b>");
if(!@include($fullpathMaintain."config.php"))
	die("Unable to include <b>config.php</b>... cannot proceed... check the <b>\"fullpathMaintain\"</b> dir is correctly set in <b>ban.php</b>");

//find ip, hostname, proxyip, proxyhostname
$current_ip = $_SERVER['REMOTE_ADDR'];
$current_ip_coded = sprintf("%u", ip2long($current_ip));
$current_hostname = gethostbyaddr($current_ip);

//vars inizialization
$using_proxy = false;
$forwaded_for_ip = "";
$forwaded_for_ip_hostname = "";

//start transparent proxy checking
if($ipblocker['proxyCheck'] && isset($_SERVER['HTTP_X_FORWARDED_FOR'])){
	$forwaded_for_ip = strtolower($_SERVER['HTTP_X_FORWARDED_FOR']);
	//control if the format is correct (xxx.xxx.xxx.xxx)
	if(!eregi("^([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3})$", $forwaded_for_ip))
		$forwaded_for_ip = "";
	if(!empty($forwaded_for_ip)){
		$forwaded_for_ip_coded = sprintf("%u", ip2long($forwaded_for_ip));
		//control if the ip forwaded_for is a private address
		//if((sprintf("%u", ip2long("0.0.0.0"))<$forwaded_for_ip_coded && $forwaded_for_ip_coded<sprintf("%u", ip2long("0.255.255.255"))) || (sprintf("%u", ip2long("10.0.0.0"))<$forwaded_for_ip_coded && $forwaded_for_ip_coded<sprintf("%u", ip2long("10.255.255.255"))) || (sprintf("%u", ip2long("192.168.0.0"))<$forwaded_for_ip_coded && $forwaded_for_ip_coded<sprintf("%u", ip2long("192.168.255.255"))) || (sprintf("%u", ip2long("240.0.0.0"))<$forwaded_for_ip_coded && $forwaded_for_ip_coded<sprintf("%u", ip2long("255.255.255.255"))) || (sprintf("%u", ip2long("127.0.0.0"))<$forwaded_for_ip_coded && $forwaded_for_ip_coded<sprintf("%u", ip2long("127.255.255.255"))) || (sprintf("%u", ip2long("172.16.0.0"))<$forwaded_for_ip_coded && $forwaded_for_ip_coded<sprintf("%u", ip2long("172.31.255.255"))))
		if((0<$forwaded_for_ip_coded && $forwaded_for_ip_coded<16777215) || (167772160<$forwaded_for_ip_coded && $forwaded_for_ip_coded<184549375) || (3232235520<$forwaded_for_ip_coded && $forwaded_for_ip_coded<3232301055) || (4026531840<$forwaded_for_ip_coded && $forwaded_for_ip_coded<4294967295) || (2130706432<$forwaded_for_ip_coded && $forwaded_for_ip_coded<2147483647) || (2886729728<$forwaded_for_ip_coded && $forwaded_for_ip_coded<2887778303))
			$forwaded_for_ip_coded = $current_ip_coded;
		else
			$forwaded_for_ip_hostname = gethostbyaddr($forwaded_for_ip);
		if($current_ip_coded != $forwaded_for_ip_coded)
			$using_proxy = true;
		else
			$using_proxy = false;
	}
}
//end ip finding

//if total_logging is enabled: log every data-ip-system
if($ipblocker['total_logging']){
	$fp = @fopen($ipblocker['fullpathLogName'].$ipblocker['total_logging_filename'], "a") or die("Error opening/creating the total logger file! cannot proceed");
	if($using_proxy && $ipblocker['proxyCheck'])
		$string = "".date($ipblocker['date_format'])." - ".$current_ip." (original ip:".$forwaded_for_ip.") - ".$_SERVER['HTTP_USER_AGENT']."\n";
	else
		$string = "".date($ipblocker['date_format'])." - ".$current_ip." - ".$_SERVER['HTTP_USER_AGENT']."\n";
	@fwrite($fp, $string) or die("Unable to write the total logger file! cannot proceed");
	@fclose($fp) or die("Unable to close the total logger file! cannot proceed");
	//file splitting
	if(filesize($ipblocker['fullpathLogName'].$ipblocker['total_logging_filename']) > $ipblocker['total_logging_filesize'] && $ipblocker['total_logging_filesize'] > 0){
		$fp = @fopen($ipblocker['fullpathLogName'].$ipblocker['total_logging_filename'],"r") or die("Error opening/creating the total logger file! cannot proceed");
		@fseek($fp, filesize($ipblocker['fullpathLogName'].$ipblocker['total_logging_filename'])-$ipblocker['total_logging_filesize']);
		$content = @fread($fp, $ipblocker['total_logging_filesize']) or die("Error reading the total logger file! cannot proceed");
		@fclose($fp);
		@unlink($ipblocker['fullpathLogName'].$ipblocker['total_logging_filename']);
		$content = implode("\n",array_slice(explode("\n",$content), 1));
		$fp = fopen($ipblocker['fullpathLogName'].$ipblocker['total_logging_filename'],"w") or die("Error opening/creating the total logger file! cannot proceed");
		@fwrite($fp, $content) or die("Unable to write the total logger file! cannot proceed");
		@fclose($fp) or die("Unable to close the total logger file! cannot proceed");
		unset($content);
	}
}
//end total_logging

//connecting to sql server
$ipblocker_connection = ipblocker_connect();

//controlling if the ip is banned
if($using_proxy && $ipblocker['proxyCheck'])
	$ipblocker_query_result = @mysql_query("SELECT rangename FROM `".$ipblocker['db_table_name']."` WHERE (start <= '".$current_ip_coded."' AND end >= '".$current_ip_coded."') OR (start <= '".$forwaded_for_ip_coded."' AND end >= '".$forwaded_for_ip_coded."') LIMIT 1", $ipblocker_connection) or die("The phpipblocker script wasn't able to run the query to the database...<br /><br />Inform the admin: ".$ipblocker['adminMail']);
else
	$ipblocker_query_result = @mysql_query("SELECT rangename FROM `".$ipblocker['db_table_name']."` WHERE start <= '".$current_ip_coded."' AND end >= '".$current_ip_coded."' LIMIT 1", $ipblocker_connection) or die("The phpipblocker script wasn't able to run the query to the database...<br /><br />Inform the admin: ".$ipblocker['adminMail']);

//main blocking routine
if(@mysql_num_rows($ipblocker_query_result) > 0){
	$ipblocker_query_result = @mysql_fetch_array($ipblocker_query_result);
	
	//remove slashes if magic_quotes is disabled
	//if (!get_magic_quotes_gpc())
		$rangename = stripslashes($ipblocker_query_result['rangename']);
		
	if($ipblocker['sendMail']){
		$mail['headers'] = "From: ".$ipblocker['adminMail']." <".$ipblocker['adminMail'].">\nReply-To: ".$ipblocker['adminMail']."\n\n";
		$mail['text'] = $rangename." has been tracked while visiting your website\n\nIp that requested the page: ".$current_ip."\nHostname: ".$current_hostname."\n\nDate: ".date($ipblocker['date_format'])."\nRequired Page: ".$_SERVER['REQUEST_URI']."\nClient Port used: ".$_SERVER['REMOTE_PORT']."\nUsed method: ".$_SERVER['REQUEST_METHOD']."\nReferer: ".$_SERVER['HTTP_REFERER']."\nSystem: ".$_SERVER['HTTP_USER_AGENT']."\n\n";
		if($using_proxy && $ipblocker['proxyCheck'])
			$mail['text'] .= "Using Transparent proxy = yes\nOriginal IP (declared by the proxy: not 100% affidable): ".$forwaded_for_ip."\nOriginal Hostname (declared by the proxy: not 100% affidable): ".$forwaded_for_ip_hostname."\n";
		elseif(!$using_proxy && $ipblocker['proxyCheck'])
			$mail['text'] .= "Using Transparent proxy = no\n";
		$mail['object'] = "[phpipblocker] ".$rangename." on your website";
		@mail($ipblocker['adminMail'], $mail['object'], $mail['text'], $mail['headers']);
	}
	if($ipblocker['logAccess']){
		switch($ipblocker['logFrequency']){
			case "day":
				$logFileName = $ipblocker['fullpathLogName']."".date("Y")."".date("m")."".date("d").".log";
				break;
			case "week":
				$logFileName = $ipblocker['fullpathLogName']."".date("Y")."".date("W").".log";
				break;
			case "month":
				$logFileName = $ipblocker['fullpathLogName']."".date("Y")."".date("m").".log";
				break;
			case "year":
				$logFileName = $ipblocker['fullpathLogName']."".date("Y").".log";
				break;
			default:
				$logFileName = $ipblocker['fullpathLogName']."".$ipblocker['logFrequency'];
				break;
		}
		$fp = @fopen ($logFileName, "a") or die("Unable to open/create the logging file! cannot proceed");
		if($using_proxy && $ipblocker['proxyCheck'])
			$string = "".date($ipblocker['date_format'])." - ".$current_ip." (original ip:".$forwaded_for_ip.") - ".$rangename." - ".$_SERVER['HTTP_USER_AGENT']."\n";
		else
			$string = "".date($ipblocker['date_format'])." - ".$current_ip." - ".$rangename." - ".$_SERVER['HTTP_USER_AGENT']."\n";
		@fwrite($fp, $string) or die("Unable to write the logging file! cannot proceed");
		@fclose($fp) or die("Unable to close the logging file! cannot proceed");
	}
	if($ipblocker['blockThem']){
		switch($ipblocker['blockType']){
			case 0:
				ipblocker_disconnect();
				header ("HTTP/1.1 404 Not Found");
				exit();
				break;
			case 1:
				ipblocker_disconnect();
				header ("HTTP/1.1 403 Forbidden");
				exit();
				break;
			case 2:
				ipblocker_disconnect();
				header ("Location: ".$ipblocker['blockRedirectURL']);
				exit();
				break;
			case 3:
				ipblocker_disconnect();
				$adminMail_encoded = ipblocker_encode_mail($ipblocker['adminMail']);
				$adminMail = "".$ipblocker['adminMail']."";
				//die("Sorry <b>".$rangename."</b><br />\nYou are not allowed to view this page\n<br />".$ipblocker['blockExplicitReference']."\n");
				$stop_text = implode('', file($fullpathMaintain."template.html"));
				$stop_text = addslashes($stop_text);
				$stop_text = "\$stop_text=\"".$stop_text."\";";
				eval($stop_text);
				$stop_text = stripslashes($stop_text);
				die($stop_text);
				break;
		}
	}
}

//disconnect from mysql server (only if it's needed)
ipblocker_disconnect();

//clean up the memory used ^_'
unset($ipblocker, $ipblocker_listLocation, $ipblocker_connection, $fullpathMaintain, $current_ip, $current_ip_coded, $using_proxy, $forwaded_for_ip, $forwaded_for_ip_hostname, $logFileName, $fp, $string, $ipblocker_query_result, $mail, $stop_text, $rangename, $current_hostname, $forwaded_for_ip, $adminMail, $adminMail_encoded);

//END SCRIPT CODE

/**********************************************************************
* This script is free software; you can redistribute it and/or        *
* modify it under the terms of the GNU Lesser General Public          *
* License as published by the Free Software Foundation.               *
*                                                                     *
* This script is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of      *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU   *
* Lesser General Public License for more details.                     *
*                                                                     *
* You should have received a copy of the GNU Lesser General Public    *
* License along with this script; if not, write to the                *
* Free Software Foundation, Inc.,                                     *
* 59 Temple Place, Suite 330,                                         *
* Boston, MA                                                          *
* 02111-1307                                                          *
* USA                                                                 *
*                                                                     *
* For further information, visit www.gnu.org                          *
**********************************************************************/

?>